<!DOCTYPE html>
<html lang="es">
<head>
	<meta charset="UTF-8">
	<title>ListaDesplegable</title>
</head>

<script type="text/javascript">


// :::: 1 :::: -> Inicializar XHR (XMLHttpRequest)
var peticion = null;

function inicializa_xhr()
{
	if (window.XMLHttpRequest) {
		// En el caso que el navegador soporte XMLHttpRequests,
		// devuelve XMLHttpRequest como nuevo objeto.
		return new XMLHttpRequest(); 
	}
}


// :::: 2 ::::
function muestraProvincias()
{
	if (peticion.readyState == 4) {
		if (peticion.status == 200) {
			var lista = document.getElementById("provincia");
			var provincias = eval('(' + peticion.responseText + ')');

			lista.options[0] = new Option("- selecciona -");
			var i=1;
			for(var codigo in provincias) {
				lista.options[i] = new Option(provincias[codigo], codigo);
				i++;
			}
		}
	}
}


// :::: 3 ::::
function cargaMunicipios()
{
	var lista = document.getElementById("provincia");
	var provincia = lista.options[lista.selectedIndex].value;
	if(!isNaN(provincia)) {
		peticion = inicializa_xhr();
		if (peticion) {
			peticion.onreadystatechange = muestraMunicipios;
			peticion.open("POST", "http://127.0.0.1:5555/servidor/cargaMunicipiosJSON.php?nocache=" + Math.random(), true);
			peticion.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			peticion.send("provincia=" + provincia);
		}
	}
}

// :::: 4 ::::
function muestraMunicipios()
{
	if (peticion.readyState == 4) {
		if (peticion.status == 200) {
			var lista = document.getElementById("municipio");
			var municipios = eval('(' + peticion.responseText + ')');

			lista.options.length = 0;
			var i=0;
			for(var codigo in municipios) {
				lista.options[i] = new Option(municipios[codigo], codigo);
				i++;
			}
		}
	}
}

// :::: 5 :::: -> Código ejecutado nada más cargar la página
window.onload = function()
{
	peticion = inicializa_xhr();
	if(peticion) {
		peticion.onreadystatechange = muestraProvincias;
		peticion.open("GET", "http://127.0.0.1:5555/servidor/cargaProvinciasJSON.php?nocache="+Math.random(), true);
		peticion.send(null);
	}

	document.getElementById("provincia").onchange = cargaMunicipios;
}

</script>
</head>

<body>
<h1>Listas desplegables encadenadas</h1>

<form>
	<label for="provincia">Provincia</label>
	<select id="provincia">
		<option>Cargando...</option>
	</select>
	<br/><br/>
	<label for="municipio">Municipio</label>
	<select id="municipio">
		<option>- selecciona una provincia -</option>
	</select>
</form>

</body>
</html>
